unit Form_Config;

interface

uses
  Registry, Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TTCPD_Config = class(TForm)
    Memo_Hints: TMemo;
    Edit_Executable: TEdit;
    Label1: TLabel;
    Memo_Params: TMemo;
    Btn_OK: TBitBtn;
    Btn_Cancel: TBitBtn;
    Edit_Sound: TEdit;
    Label2: TLabel;
    Btn_Info: TBitBtn;
    Label3: TLabel;
    procedure Btn_OKClick(Sender: TObject);
    procedure Btn_CancelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Btn_InfoClick(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    procedure LoadFromRegistry;
    procedure SaveToRegistry;
  end;

var
  TCPD_Config: TTCPD_Config;


implementation

uses U_Constants, Form_Info;

{$R *.DFM}

{==============================================================================}
procedure TTCPD_Config.SaveToRegistry;
var TheReg: TRegistry;
  n, i: Integer;
begin
  TheReg := TRegistry.Create;
  try
    TheReg.RootKey := RegRootKey;
    TheReg.OpenKey(RegKey, true);

    TheReg.WriteString('executable', Edit_Executable.Text);

    TheReg.WriteString('sound', Edit_sound.Text);

    n := 0;
    while TheReg.ValueExists('param' + IntToStr(n)) do
      begin
        try
          TheReg.DeleteValue('param' + IntToStr(n));
        finally
          inc(n);
        end;
      end;

    if Memo_Params.Lines.Count > 0 then
      begin
        n := 0;
        for i := 0 to Memo_Params.Lines.Count - 1 do
          begin
            if length(Trim(Memo_Params.Lines[i])) > 3  then
              begin
                TheReg.WriteString('param' + IntToStr(n), Memo_Params.Lines[i]);
                inc(n);
              end;
          end;
      end;

  finally
    TheReg.Free;
  end;
end;
{==============================================================================}
procedure TTCPD_Config.LoadFromRegistry;
var TheReg: TRegistry;
  n: Integer;
begin
  TheReg := TRegistry.Create;
  try
    TheReg.RootKey := RegRootKey;
    TheReg.OpenKey(RegKey, true);

    Edit_Executable.Text := TheReg.ReadString('executable');

    Edit_Sound.Text := TheReg.ReadString('sound');

    Memo_Params.Lines.Clear;

    n := 0;

    while TheReg.ValueExists('param' + IntToStr(n)) do
      begin
        try
          Memo_Params.Lines.Add(TheReg.ReadString('param' + IntToStr(n)));
        finally
          inc(n);
        end;
      end;

  finally
    TheReg.Free;
  end;
end;
{==============================================================================}
procedure TTCPD_Config.Btn_OKClick(Sender: TObject);
begin
  SaveToRegistry;
  LoadFromRegistry;
  Close;
end;
{==============================================================================}
procedure TTCPD_Config.Btn_CancelClick(Sender: TObject);
begin
  Close;
end;
{==============================================================================}
procedure TTCPD_Config.FormShow(Sender: TObject);
begin
  LoadFromRegistry;
end;
{==============================================================================}
procedure TTCPD_Config.Btn_InfoClick(Sender: TObject);
begin
TCPD_InfoDialog.ShowModal;
end;

end.

